#
#  eraseobj.cl
#

procedure       eraseobj( imlist, outlist, coords )

file    imlist          {prompt = "Input image list with @ mark"}
file    outlist         {prompt = "Output image list with @ mark"}
file    coords          {prompt = "Input coordinate list"}

struct  *list1    {mode = 'h'}
struct  *list2    {mode = 'h'}
struct  *list3    {mode = 'h'}
#
#
begin
        string  tmpfile1, tmpfile2, tmpfile3
        string  junk1, junk2, junk3
        string  tmpimage1, tmpimage2, tmpimage3, tmpimage4, tmpimage5
        string  tmpimage6, tmpimage7, tmpimage8, tmpimage9, tmpimagea,tmpimageb
        string  imlist1, outlist1, coords1
        int     i, x, y

        imlist1 = imlist
        outlist1 = outlist
        coords1 = coords
        tmpfile1 = mktemp( "tmp_file." )
        tmpfile2 = mktemp( "tmp_file." )
        tmpfile3 = mktemp( "tmp_file." )
        sections( imlist1, option='fullname', > tmpfile1 )
        sections( outlist1, option='fullname', > tmpfile2 )
        sections( coords1, option='fullname', > tmpfile3 )  
        list1 = tmpfile1
        list2 = tmpfile2
        list3 = tmpfile3

        while( fscan( list1, junk1 ) == 1 ) {
          if( fscan( list2, junk2 ) == 1 ) {
            tmpimage1 = mktemp( "tmp_im." )
            tmpimage2 = mktemp( "tmp_im." )
            tmpimage3 = mktemp( "tmp_im." )
            tmpimage4 = mktemp( "tmp_im." )
            tmpimage5 = mktemp( "tmp_im." )
            tmpimage6 = mktemp( "tmp_im." )
            tmpimage7 = mktemp( "tmp_im." )
            tmpimage8 = mktemp( "tmp_im." )
            tmpimage9 = mktemp( "tmp_im." )
            tmpimagea = mktemp( "tmp_im." )
            tmpimageb = mktemp( "tmp_im." )
            imcopy( junk1, tmpimage1 )
            median( junk1//"[1:512,*]", tmpimage2, 5, 5 )
            median( junk1//"[513:1024,*]", tmpimage3, 5, 5 )
            imcopy( tmpimage2, tmpimage1//"[1:512,*]" )
            imcopy( tmpimage3, tmpimage1//"[513:1024,*]" )
          i=0;
          while( fscan( list3, junk3 ) != EOF ){
            imedit( tmpimage1, tmpimage4, cursor=junk3, display-, radius=10+10*i, search=0, buffer=20, width=20 )
            imdelete( tmpimage1 )
            imedit( tmpimage4, tmpimage1, cursor=junk3, display-, radius=10+10*i, search=0, buffer=20, width=20 )
            imdel( tmpimage4 )
            print("i=",i)
            i=i+1 
          }
            blkavg( tmpimage1//"[*,51:974]", tmpimage5, 1, 2000 )
            magnify( tmpimage5, tmpimage6, 1., 0.0009765625, y2=1024, dy=1, interpo='nearest', boundar='nearest', fluxcon- )
            imarith( tmpimage1, "-", tmpimage6, tmpimage7 )
            imsurfit( tmpimage7, tmpimage8, 10, 10, xmedian=5, ymedian=5, type_ou='fit' )
            imarith( tmpimage6, "+", tmpimage8, tmpimage9 )
            imarith( junk1, "-", tmpimage9, tmpimagea )

          i=0;
          list3 = tmpfile3
          while( fscan( list3, junk3 ) != EOF ){
            imedit( tmpimagea, tmpimageb, cursor=junk3, display-, radius=10+10*i, search=0, buffer=20, width=20 )
            imdelete(tmpimagea)
            imedit( tmpimageb, tmpimagea, cursor=junk3, display-, radius=10+10*i, search=0, buffer=20, width=20 )
            imdelete(tmpimageb)
            print("i=",i)
            i=i+1 
          }

            imarith( tmpimagea, "+", tmpimage9, junk2 )
	    
            display( junk2 , 1, fi+, zs+, zr+ )

            imdelete( tmpimage1 )
            imdelete( tmpimage2 )
            imdelete( tmpimage3 )
            imdelete( tmpimage4 )
            imdelete( tmpimage5 )
            imdelete( tmpimage6 )
            imdelete( tmpimage7 )
            imdelete( tmpimage8 )
            imdelete( tmpimage9 )
            imdelete( tmpimagea )
            imdelete( tmpimageb )
            }}
        delete( tmpfile1,ver-,>&"dev$null" )
        delete( tmpfile2,ver-,>&"dev$null" )
        bye
end



